Index: squid/src/auth/ntlm/auth_ntlm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/ntlm/auth_ntlm.c,v
retrieving revision 1.1.2.35
retrieving revision 1.1.2.36
diff -u -r1.1.2.35 -r1.1.2.36
--- squid/src/auth/ntlm/auth_ntlm.c	9 Feb 2001 17:40:56 -0000	1.1.2.35
+++ squid/src/auth/ntlm/auth_ntlm.c	10 Feb 2001 17:32:49 -0000	1.1.2.36
@@ -42,9 +42,9 @@
 #include "auth_ntlm.h"
 
 static void
-authenticateStateFree (authenticateStateData * r)
+authenticateStateFree(authenticateStateData * r)
 {
-  cbdataFree (r);
+    cbdataFree(r);
 }
 
 /* NTLM Scheme */
@@ -75,7 +75,7 @@
 
 static statefulhelper *ntlmauthenticators = NULL;
 
-CBDATA_TYPE (authenticateStateData);
+CBDATA_TYPE(authenticateStateData);
 
 static int authntlm_initialised = 0;
 
@@ -93,209 +93,191 @@
  */
 
 void
-authNTLMDone (void)
+authNTLMDone(void)
 {
-  debug (29, 2) ("authNTLMDone: shutting down NTLM authentication.\n");
-  if (ntlmauthenticators)
-    helperStatefulShutdown (ntlmauthenticators);
-  authntlm_initialised = 0;
-  if (!shutting_down)
-    return;
-  if (ntlmauthenticators)
-    helperStatefulFree (ntlmauthenticators);
-  ntlmauthenticators = NULL;
-  if (ntlm_helper_state_pool)
-    {
-      assert (memPoolInUseCount (ntlm_helper_state_pool) == 0);
-      memPoolDestroy (ntlm_helper_state_pool);
-      ntlm_helper_state_pool = NULL;
-    }
-  if (ntlm_request_pool)
-    {
-      assert (memPoolInUseCount (ntlm_request_pool) == 0);
-      memPoolDestroy (ntlm_request_pool);
-      ntlm_request_pool = NULL;
-    }
-  if (ntlm_user_pool)
-    {
-      assert (memPoolInUseCount (ntlm_user_pool) == 0);
-      memPoolDestroy (ntlm_user_pool);
-      ntlm_user_pool = NULL;
+    debug(29, 2) ("authNTLMDone: shutting down NTLM authentication.\n");
+    if (ntlmauthenticators)
+	helperStatefulShutdown(ntlmauthenticators);
+    authntlm_initialised = 0;
+    if (!shutting_down)
+	return;
+    if (ntlmauthenticators)
+	helperStatefulFree(ntlmauthenticators);
+    ntlmauthenticators = NULL;
+    if (ntlm_helper_state_pool) {
+	assert(memPoolInUseCount(ntlm_helper_state_pool) == 0);
+	memPoolDestroy(ntlm_helper_state_pool);
+	ntlm_helper_state_pool = NULL;
+    }
+    if (ntlm_request_pool) {
+	assert(memPoolInUseCount(ntlm_request_pool) == 0);
+	memPoolDestroy(ntlm_request_pool);
+	ntlm_request_pool = NULL;
+    }
+    if (ntlm_user_pool) {
+	assert(memPoolInUseCount(ntlm_user_pool) == 0);
+	memPoolDestroy(ntlm_user_pool);
+	ntlm_user_pool = NULL;
     }
-  debug (29, 2) ("authNTLMDone: NTLM authentication Shutdown.\n");
+    debug(29, 2) ("authNTLMDone: NTLM authentication Shutdown.\n");
 }
 
 /* free any allocated configuration details */
 void
-authNTLMFreeConfig (authScheme * scheme)
+authNTLMFreeConfig(authScheme * scheme)
 {
-  if (ntlmConfig == NULL)
-    return;
-  assert (ntlmConfig == scheme->scheme_data);
-  if (ntlmConfig->authenticate)
-    wordlistDestroy (&ntlmConfig->authenticate);
-  xfree (ntlmConfig);
-  ntlmConfig = NULL;
+    if (ntlmConfig == NULL)
+	return;
+    assert(ntlmConfig == scheme->scheme_data);
+    if (ntlmConfig->authenticate)
+	wordlistDestroy(&ntlmConfig->authenticate);
+    xfree(ntlmConfig);
+    ntlmConfig = NULL;
 }
 
 static void
-authNTLMCfgDump (StoreEntry * entry, const char *name, authScheme * scheme)
+authNTLMCfgDump(StoreEntry * entry, const char *name, authScheme * scheme)
 {
-  auth_ntlm_config *config = scheme->scheme_data;
-  wordlist *list = config->authenticate;
-  storeAppendPrintf (entry, "%s %s", name, "ntlm");
-  while (list != NULL)
-    {
-      storeAppendPrintf (entry, " %s", list->key);
-      list = list->next;
+    auth_ntlm_config *config = scheme->scheme_data;
+    wordlist *list = config->authenticate;
+    storeAppendPrintf(entry, "%s %s", name, "ntlm");
+    while (list != NULL) {
+	storeAppendPrintf(entry, " %s", list->key);
+	list = list->next;
     }
-  storeAppendPrintf (entry, "\n%s %s children %d\n%s %s max_challenge_reuses %d\n%s %s max_challenge_lifetime %d seconds\n", name, "ntlm", config->authenticateChildren, name, "ntlm", config->challengeuses, name, "ntlm", config->challengelifetime);
+    storeAppendPrintf(entry, "\n%s %s children %d\n%s %s max_challenge_reuses %d\n%s %s max_challenge_lifetime %d seconds\n", name, "ntlm", config->authenticateChildren, name, "ntlm", config->challengeuses, name, "ntlm", config->challengelifetime);
 
 }
 
 static void
-authNTLMParse (authScheme * scheme, int n_configured, char *param_str)
+authNTLMParse(authScheme * scheme, int n_configured, char *param_str)
 {
-  if (scheme->scheme_data == NULL)
-    {
-      assert (ntlmConfig == NULL);
-      /* this is the first param to be found */
-      scheme->scheme_data = xmalloc (sizeof (auth_ntlm_config));
-      memset (scheme->scheme_data, 0, sizeof (auth_ntlm_config));
-      ntlmConfig = scheme->scheme_data;
-      ntlmConfig->authenticateChildren = 5;
-      ntlmConfig->challengeuses = 0;
-      ntlmConfig->challengelifetime = 60;
-    }
-  ntlmConfig = scheme->scheme_data;
-  if (strcasecmp (param_str, "program") == 0)
-    {
-      if (ntlmConfig->authenticate)
-	wordlistDestroy (&ntlmConfig->authenticate);
-      parse_wordlist (&ntlmConfig->authenticate);
-      requirePathnameExists ("authparam ntlm program", ntlmConfig->authenticate->key);
-    }
-  else if (strcasecmp (param_str, "children") == 0)
-    {
-      parse_int (&ntlmConfig->authenticateChildren);
-    }
-  else if (strcasecmp (param_str, "max_challenge_reuses") == 0)
-    {
-      parse_int (&ntlmConfig->challengeuses);
-    }
-  else if (strcasecmp (param_str, "max_challenge_lifetime") == 0)
-    {
-      parse_time_t (&ntlmConfig->challengelifetime);
-    }
-  else
-    {
-      debug (28, 0) ("unrecognised ntlm auth scheme parameter '%s'\n", param_str);
+    if (scheme->scheme_data == NULL) {
+	assert(ntlmConfig == NULL);
+	/* this is the first param to be found */
+	scheme->scheme_data = xmalloc(sizeof(auth_ntlm_config));
+	memset(scheme->scheme_data, 0, sizeof(auth_ntlm_config));
+	ntlmConfig = scheme->scheme_data;
+	ntlmConfig->authenticateChildren = 5;
+	ntlmConfig->challengeuses = 0;
+	ntlmConfig->challengelifetime = 60;
+    }
+    ntlmConfig = scheme->scheme_data;
+    if (strcasecmp(param_str, "program") == 0) {
+	if (ntlmConfig->authenticate)
+	    wordlistDestroy(&ntlmConfig->authenticate);
+	parse_wordlist(&ntlmConfig->authenticate);
+	requirePathnameExists("authparam ntlm program", ntlmConfig->authenticate->key);
+    } else if (strcasecmp(param_str, "children") == 0) {
+	parse_int(&ntlmConfig->authenticateChildren);
+    } else if (strcasecmp(param_str, "max_challenge_reuses") == 0) {
+	parse_int(&ntlmConfig->challengeuses);
+    } else if (strcasecmp(param_str, "max_challenge_lifetime") == 0) {
+	parse_time_t(&ntlmConfig->challengelifetime);
+    } else {
+	debug(28, 0) ("unrecognised ntlm auth scheme parameter '%s'\n", param_str);
     }
 }
 
 
 void
-authSchemeSetup_ntlm (authscheme_entry_t * authscheme)
-{
-  assert (!authntlm_initialised);
-  authscheme->Active = authenticateNTLMActive;
-  authscheme->configured = authNTLMConfigured;
-  authscheme->parse = authNTLMParse;
-  authscheme->dump = authNTLMCfgDump;
-  authscheme->requestFree = authNTLMAURequestFree;
-  authscheme->freeconfig = authNTLMFreeConfig;
-  authscheme->init = authNTLMInit;
-  authscheme->authAuthenticate = authenticateNTLMAuthenticateUser;
-  authscheme->authenticated = authNTLMAuthenticated;
-  authscheme->authFixHeader = authenticateNTLMFixErrorHeader;
-  authscheme->FreeUser = authenticateNTLMFreeUser;
-  authscheme->authStart = authenticateNTLMStart;
-  authscheme->authStats = authenticateNTLMStats;
-  authscheme->authUserUsername = authenticateNTLMUsername;
-  authscheme->getdirection = authenticateNTLMDirection;
-  authscheme->decodeauth = authenticateDecodeNTLMAuth;
-  authscheme->donefunc = authNTLMDone;
-  authscheme->oncloseconnection = authenticateNTLMOnCloseConnection;
+authSchemeSetup_ntlm(authscheme_entry_t * authscheme)
+{
+    assert(!authntlm_initialised);
+    authscheme->Active = authenticateNTLMActive;
+    authscheme->configured = authNTLMConfigured;
+    authscheme->parse = authNTLMParse;
+    authscheme->dump = authNTLMCfgDump;
+    authscheme->requestFree = authNTLMAURequestFree;
+    authscheme->freeconfig = authNTLMFreeConfig;
+    authscheme->init = authNTLMInit;
+    authscheme->authAuthenticate = authenticateNTLMAuthenticateUser;
+    authscheme->authenticated = authNTLMAuthenticated;
+    authscheme->authFixHeader = authenticateNTLMFixErrorHeader;
+    authscheme->FreeUser = authenticateNTLMFreeUser;
+    authscheme->authStart = authenticateNTLMStart;
+    authscheme->authStats = authenticateNTLMStats;
+    authscheme->authUserUsername = authenticateNTLMUsername;
+    authscheme->getdirection = authenticateNTLMDirection;
+    authscheme->decodeauth = authenticateDecodeNTLMAuth;
+    authscheme->donefunc = authNTLMDone;
+    authscheme->oncloseconnection = authenticateNTLMOnCloseConnection;
 }
 
 /* Initialize helpers and the like for this auth scheme. Called AFTER parsing the
  * config file */
 static void
-authNTLMInit (authScheme * scheme)
+authNTLMInit(authScheme * scheme)
 {
-  static int ntlminit = 0;
-  if (ntlmConfig->authenticate)
-    {
-      if (!ntlm_helper_state_pool)
-	ntlm_helper_state_pool = memPoolCreate ("NTLM Helper State data", sizeof (ntlm_helper_state_t));
-      if (!ntlm_user_pool)
-	ntlm_user_pool = memPoolCreate ("NTLM Scheme User Data", sizeof (ntlm_user_t));
-      if (!ntlm_request_pool)
-	ntlm_request_pool = memPoolCreate ("NTLM Scheme Request Data", sizeof (ntlm_request_t));
-      authntlm_initialised = 1;
-      if (ntlmauthenticators == NULL)
-	ntlmauthenticators = helperStatefulCreate ("ntlmauthenticator");
-      if (!proxy_auth_cache)
-	proxy_auth_cache = hash_create ((HASHCMP *) strcmp, 7921, hash_string);
-      assert (proxy_auth_cache);
-      ntlmauthenticators->cmdline = ntlmConfig->authenticate;
-      ntlmauthenticators->n_to_start = ntlmConfig->authenticateChildren;
-      ntlmauthenticators->ipc_type = IPC_TCP_SOCKET;
-      ntlmauthenticators->datapool = ntlm_helper_state_pool;
-      ntlmauthenticators->IsAvailable = authenticateNTLMHelperServerAvailable;
-      ntlmauthenticators->OnEmptyQueue = authenticateNTLMHelperServerOnEmpty;
-      helperStatefulOpenServers (ntlmauthenticators);
-      /* TODO: In here send the initial YR to preinitialise the challenge cache */
-      /* Think about this... currently we ask when the challenge is needed. Better? */
-      if (!ntlminit)
-	{
-	  cachemgrRegister ("ntlmauthenticator", "User NTLM Authenticator Stats", authenticateNTLMStats, 0, 1);
-	  ntlminit++;
+    static int ntlminit = 0;
+    if (ntlmConfig->authenticate) {
+	if (!ntlm_helper_state_pool)
+	    ntlm_helper_state_pool = memPoolCreate("NTLM Helper State data", sizeof(ntlm_helper_state_t));
+	if (!ntlm_user_pool)
+	    ntlm_user_pool = memPoolCreate("NTLM Scheme User Data", sizeof(ntlm_user_t));
+	if (!ntlm_request_pool)
+	    ntlm_request_pool = memPoolCreate("NTLM Scheme Request Data", sizeof(ntlm_request_t));
+	authntlm_initialised = 1;
+	if (ntlmauthenticators == NULL)
+	    ntlmauthenticators = helperStatefulCreate("ntlmauthenticator");
+	if (!proxy_auth_cache)
+	    proxy_auth_cache = hash_create((HASHCMP *) strcmp, 7921, hash_string);
+	assert(proxy_auth_cache);
+	ntlmauthenticators->cmdline = ntlmConfig->authenticate;
+	ntlmauthenticators->n_to_start = ntlmConfig->authenticateChildren;
+	ntlmauthenticators->ipc_type = IPC_TCP_SOCKET;
+	ntlmauthenticators->datapool = ntlm_helper_state_pool;
+	ntlmauthenticators->IsAvailable = authenticateNTLMHelperServerAvailable;
+	ntlmauthenticators->OnEmptyQueue = authenticateNTLMHelperServerOnEmpty;
+	helperStatefulOpenServers(ntlmauthenticators);
+	/* TODO: In here send the initial YR to preinitialise the challenge cache */
+	/* Think about this... currently we ask when the challenge is needed. Better? */
+	if (!ntlminit) {
+	    cachemgrRegister("ntlmauthenticator", "User NTLM Authenticator Stats", authenticateNTLMStats, 0, 1);
+	    ntlminit++;
 	}
-      CBDATA_INIT_TYPE (authenticateStateData);
+	CBDATA_INIT_TYPE(authenticateStateData);
     }
 }
 
 int
-authenticateNTLMActive ()
+authenticateNTLMActive()
 {
-  return (authntlm_initialised == 1) ? 1 : 0;
+    return (authntlm_initialised == 1) ? 1 : 0;
 }
 
 
 int
-authNTLMConfigured ()
+authNTLMConfigured()
 {
-  if ((ntlmConfig != NULL) && (ntlmConfig->authenticate != NULL) && (ntlmConfig->authenticateChildren != 0) && (ntlmConfig->challengeuses > -1) && (ntlmConfig->challengelifetime > -1))
-    {
-      debug (29, 9) ("authNTLMConfigured: returning configured\n");
-      return 1;
+    if ((ntlmConfig != NULL) && (ntlmConfig->authenticate != NULL) && (ntlmConfig->authenticateChildren != 0) && (ntlmConfig->challengeuses > -1) && (ntlmConfig->challengelifetime > -1)) {
+	debug(29, 9) ("authNTLMConfigured: returning configured\n");
+	return 1;
     }
-  debug (29, 9) ("authNTLMConfigured: returning unconfigured\n");
-  return 0;
+    debug(29, 9) ("authNTLMConfigured: returning unconfigured\n");
+    return 0;
 }
 
 /* NTLM Scheme */
 
 int
-authenticateNTLMDirection (auth_user_request_t * auth_user_request)
+authenticateNTLMDirection(auth_user_request_t * auth_user_request)
 {
-  ntlm_request_t *ntlm_request = auth_user_request->scheme_data;
+    ntlm_request_t *ntlm_request = auth_user_request->scheme_data;
 /* null auth_user is checked for by authenticateDirection */
-  switch (ntlm_request->auth_state)
-    {
+    switch (ntlm_request->auth_state) {
     case AUTHENTICATE_STATE_NONE:	/* no progress at all. */
-      debug (28, 1) ("authenticateNTLMDirection: called before NTLM Authenticate!. Report a bug to squid-dev.\n");
-      return -2;
-    case AUTHENTICATE_STATE_NEGOTIATE:	/* send to helper */
+	debug(28, 1) ("authenticateNTLMDirection: called before NTLM Authenticate!. Report a bug to squid-dev.\n");
+	return -2;
+    case AUTHENTICATE_STATE_NEGOTIATE:		/* send to helper */
     case AUTHENTICATE_STATE_RESPONSE:	/*send to helper */
-      return -1;
-    case AUTHENTICATE_STATE_CHALLENGE:	/* send to client */
-      return 1;
+	return -1;
+    case AUTHENTICATE_STATE_CHALLENGE:		/* send to client */
+	return 1;
     case AUTHENTICATE_STATE_DONE:	/* do nothing.. */
-      return 0;
+	return 0;
     }
-  return -2;
+    return -2;
 }
 
 /*
